#include <stdlib.mqh>

//+------------------------------------------------------------------+
//|                                               KPHighlights#2.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Marco Taggiasco aka ontherun"
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 CornflowerBlue
#property indicator_color2 DeepPink
#property indicator_color3 Yellow
#property indicator_color4 Yellow

//+------------------------------------------------------------------+
//| Common External variables                                        |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| External variables                                               |
//+------------------------------------------------------------------+
extern double nAccountedBars = 300;

//+------------------------------------------------------------------+
//| Special Convertion Functions                                     |
//+------------------------------------------------------------------+

int LastTradeTime;
double ExtHistoBuffer[];
double ExtHistoBuffer2[];
double ExtHistoBuffer3[];
double ExtHistoBuffer4[];

void SetLoopCount(int loops)
{
}

void SetIndexValue(int shift, double value)
{
  ExtHistoBuffer[shift] = value;
}

void SetIndexValue2(int shift, double value)
{
  ExtHistoBuffer2[shift] = value;
}

void SetIndexValue3(int shift, double value)
{
  ExtHistoBuffer3[shift] = value;
}
void SetIndexValue4(int shift, double value)
{
  ExtHistoBuffer4[shift] = value;
}

//+------------------------------------------------------------------+
//| End                                                              |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Initialization                                                   |
//+------------------------------------------------------------------+

int init()
{
   SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID,5,CornflowerBlue);
   SetIndexBuffer(0, ExtHistoBuffer);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID,5,DeepPink);
   SetIndexBuffer(1, ExtHistoBuffer2);
   SetIndexStyle(2, DRAW_HISTOGRAM, STYLE_SOLID,5,Yellow);
   SetIndexBuffer(2, ExtHistoBuffer3);
   SetIndexStyle(3, DRAW_HISTOGRAM, STYLE_SOLID,5,Yellow);
   SetIndexBuffer(3, ExtHistoBuffer4);
   return(0);
}
int start()
{
//+------------------------------------------------------------------+
//| Local variables                                                  |
//+------------------------------------------------------------------+
int CurrentBar = 0;
double price = 0;

double FM,SM;
SetLoopCount(0);

for(CurrentBar =0;CurrentBar <=nAccountedBars ;CurrentBar ++)

{ FM=iMA(NULL,0,3,0,MODE_EMA,PRICE_CLOSE,CurrentBar)-iMA(NULL,0,10,0,MODE_EMA,PRICE_CLOSE,CurrentBar);
  SM=iMA(NULL,0,4,0,MODE_EMA,PRICE_CLOSE,CurrentBar)-iMA(NULL,0,18,0,MODE_EMA,PRICE_CLOSE,CurrentBar);
   SetIndexValue(CurrentBar, EMPTY_VALUE);
   SetIndexValue2(CurrentBar, EMPTY_VALUE);
   SetIndexValue3(CurrentBar, EMPTY_VALUE);
   SetIndexValue4(CurrentBar, EMPTY_VALUE);
  
   if( FM>0 && SM>0 ) 
   {
      SetIndexValue(CurrentBar, High[CurrentBar]);
      SetIndexValue2(CurrentBar, Low[CurrentBar]);
      continue;
   }
   if( FM<0 && SM<0 ) 
   {
      SetIndexValue(CurrentBar, Low[CurrentBar]);
      SetIndexValue2(CurrentBar, High[CurrentBar]);
      continue;
   }

      SetIndexValue3(CurrentBar, Low[CurrentBar]);
      SetIndexValue4(CurrentBar, High[CurrentBar]);
   }
   return(0);
}